PROGRAM Leise_rieselt_der_Schnee; 

        { Rekursion : Einige graphische Beispiele                }
        { Dazu sind einige einfache Turtle-Graphik-Prozeduren    }
        { notwendig. Ein 80X87 hilft etwa mit Faktor drei.       }
        { Die Beispiele sind ohne Rekursion nur sehr muehsam     }
        { algorithmisierbar. Die Graphiken lassen ihre rekursive }
        { Struktur in besonders anschaulicher Weise sichtbar     }
        { werden.                                                }

USES Turtle;

VAR  K        : INTEGER;

PROCEDURE Zacken (Stufe : INTEGER; Laenge : Reell);
VAR  Neulaenge : Reell;
BEGIN
Neulaenge := Laenge / 3;
IF Stufe > 0 THEN
     BEGIN
     Zacken (Pred (Stufe), Neulaenge);
     Drehelinks (60);
     Zacken (Pred (Stufe), Neulaenge);
     Dreherechts (120);
     Zacken (Pred (Stufe), Neulaenge);
     Drehelinks (60);
     Zacken (Pred (Stufe), Neulaenge);
     END
ELSE Vorwaerts (Laenge);
END;

PROCEDURE Zick (Stufe : INTEGER; Laenge : Reell);
VAR  Neulaenge : Reell;
BEGIN
Neulaenge := Laenge / 3;
IF Stufe > 0 THEN
     BEGIN
     Drehelinks (60);
     Zick (Pred (Stufe), Neulaenge);
     Dreherechts (120);
     Zick (Pred (Stufe), Neulaenge);
     Zick (Pred (Stufe), Neulaenge);
     Drehelinks (120);
     Zick (Pred (Stufe), Neulaenge);
     Zick (Pred (Stufe), Neulaenge);
     Dreherechts (120);
     Zick (Pred (Stufe), Neulaenge);
     Drehelinks (60);
     END
ELSE Vorwaerts (Laenge);
END;

PROCEDURE ZickZack (Stufe : INTEGER; Laenge : Reell;
                    Orientierung : INTEGER);
VAR  Neulaenge : Reell;
BEGIN
Neulaenge := Laenge / 3;
IF Stufe > 0 THEN
     BEGIN
     Orientierung := - Orientierung;
     Drehe (60 * Orientierung);
     ZickZack (Pred (Stufe), Neulaenge,  Orientierung);
     Drehe (- 120 * Orientierung);
     ZickZack (Pred (Stufe), Neulaenge,  Orientierung);
     ZickZack (Pred (Stufe), Neulaenge, - Orientierung);
     Drehe (120 * Orientierung);
     ZickZack (Pred (Stufe), Neulaenge, - Orientierung);
     ZickZack (Pred (Stufe), Neulaenge,  Orientierung);
     Drehe (- 120 * Orientierung);
     ZickZack (Pred (Stufe), Neulaenge,  Orientierung);
     Drehe (60 * Orientierung);
     END
ELSE Vorwaerts (Laenge);
END;


PROCEDURE Schneeflocke (Stufe : INTEGER; Laenge : Reell);
BEGIN
Zacken (Stufe, Laenge);
Dreherechts (120);
Zacken (Stufe, Laenge);
Dreherechts (120);
Zacken (Stufe, Laenge);
Dreherechts (120);
END;

PROCEDURE DreiZickZack (Stufe : INTEGER; Laenge : Reell);
BEGIN
ZickZack (Stufe, Laenge, - 1);
Dreherechts (120);
ZickZack (Stufe, Laenge, - 1);
Dreherechts (120);
ZickZack (Stufe, Laenge, - 1);
Dreherechts (120);
END;


BEGIN
InitGraphik;

ClearScreen;
Pendown;
Positionauf (- 900, 0);
Winkelauf (0);
Zacken (4, 1800);
Piep;
Warte;

Pencolor (Weiss);
ClearScreen;
Positionauf (- 600, 300);
Winkelauf (0);
Schneeflocke (4, 1200);
Piep;
Warte;

ClearScreen;
FOR K := 0 TO 4 DO BEGIN
     Positionauf (- 600, 300);
     Winkelauf ( 0);
     Schneeflocke (K, 1200);
END;
Piep;
Warte;

ClearScreen;
Positionauf (- 800, 0);
Winkelauf ( 0);
Zick (3, 1600);
Piep;
Warte;

ClearScreen;
Positionauf (- 800, 0);
Winkelauf ( 0);
ZickZack (4, 1600, + 1);
Piep;
Warte;

ClearScreen;
FOR K := 0 TO 4 DO BEGIN
     Positionauf (- 500, 300);
     Winkelauf ( 0);
     DreiZickZack (K, 1000);
END;
Piep;
Warte;

EndGraphik;
END.
