PROGRAM Baum_des_Pythagoras; {15.04.1988}

USES TURTLE;


VAR   Alpha,
      Sinus_Alpha,
      Cosinus_Alpha : Reell;
      MaximalStufe  : INTEGER;
      Pi_durch_180  : Reell;

(* ------------------------------------------------------ *)
PROCEDURE Pythagoras (Stufe  : INTEGER;
                      Laenge : Reell);
VAR  KantenNummer : INTEGER;
BEGIN
PenDown;
FOR KantenNummer := 1 TO 4 DO BEGIN
     Vorwaerts (Laenge);
     DreheRechts (90.0);
END; {for KantenNummer}

IF Laenge > 5 THEN
     BEGIN
     PenUp;
     Vorwaerts (Laenge);
     DreheLinks (Alpha);

     Pythagoras (Pred (Stufe), Laenge * Cosinus_Alpha);

     DreheRechts (90.0);
     Vorwaerts (Laenge * Cosinus_Alpha);

     Pythagoras (Pred (Stufe), Laenge * Sinus_Alpha);

     Vorwaerts (-Laenge * Cosinus_Alpha);
     DreheLinks (90.0 - Alpha);
     Vorwaerts (-Laenge);
     END;
END; {Pythagoras}

(* ------------------------------------------------------ *)
PROCEDURE Action;
BEGIN
  MaximalStufe  := 25;
  Alpha         := 30.0;
  Sinus_Alpha   := Sin (Alpha * Pi_durch_180);
  Cosinus_Alpha := Cos (Alpha * Pi_durch_180);
  SchriftStil (Triplexfont);
  SchriftGroesse (Gross);
  Schreibe (- 600, 700, 'Der Baum des Pythagoras');

  PenUp;
  Vorwaerts (180.0);
  DreheLinks (90.0);
  Vorwaerts (-600.0);
  PenDown;
  Pythagoras (MaximalStufe, 260);
END; (* Action *)


BEGIN  { Hauptprogramm }

(*
  GraphDriver := IBM8514;
  Graphmode   := IBM8514Hi;
*)

  InitGraphik;
  Pi_durch_180 := PI / 180.0;

  (* InitPlotter (HPGL, A4, Querformat, 'PYTH.HP'); *)
  Action;
  (* ExitPlotter; *)
  Piep; Warte;
  EndGraphik;
END.
